Subject: Re: new apple user help.
From: [email-masked] (David Empson)
Date: 5 Jul 1996 08:55:03 +1200
Newsgroups: comp.sys.apple2

In article <[email-masked]>,
Tom Zuchowski  <[email-masked]> wrote:
> David Graham <[email-masked]> wrote:
> >I collect older computers. I just got my FIRST apple two. It is a IIc, 
> >where can I get a cable to use a modem? What is a decent, comm program 
> >for it, and what is the fastest modem I can put on here. I was told 2400, 
> >but I see that you can configure a printer to 19200 so can you gothatr 
> >fast on the 2c on the modem port? Thanx for any help.
> 
> You should be able to buy or order the proper cable from almost any 
> computer store that carries Mac stuff.

Only if they are able to get cables other than Mac ones.  The IIc
doesn't use the same connector as the Mac (it has a DIN-5 instead of a
Mini-Din-8).  The IIc+ and IIgs are the only Apple II models that use a
Mini-Din-8 (plus the Apple II Workstation Card for the enhanced IIe).

Here is the pinout of the IIc serial port.  Looking at the computer
from the back, the pins are numbered:

5       1
 4     2
    3

The functions are:

1  Handshake Out (nominally DTR)
2  Data Out (TxD)
3  Ground
4  Data In (RxD)
5  Handshake In (nominally DSR)

To wire up a IIc to a simple modem without hardware handshaking, use
the following pinout:

IIc     Modem
DIN-5   DB-25M

1 ----- 20 DTR
2 ----- 2  TxD
3 ----- 7  Gnd
4 ----- 3  RxD
5 ----- 6  DSR   (you might want to use pin 8, DCD in some cases)

The IIc cannot do hardware handshaking very well, but this is as close
as you can get:

IIc     Modem
DIN-5   DB-25M

1 ----- 4  RTS
2 ----- 2  TxD
3 ----- 7  Gnd
4 ----- 3  RxD
5 ----- 5  CTS

The IIc's handshaking lines have annoying side effects, which cause
problems with hardware handshaking:

1. The "Handshake Out" signal is implemented to mean "I want to send
   data" (the official and original meaning of RTS).  If you turn off
   the output handshake line, the IIc will stop sending data.  For a
   hardware handshaking modem, RTS is supposed to mean "You are allowed
   to send me data" (from the computer's point of view).

   If the computer tells the modem to stop transmitting, the computer
   will also be unable to transmit.  This will reduce the rate at which
   data can be transferred bidirectionally, but doesn't cause any other
   problems.  

2. The "Handshake In" signal is implemented to mean "There is receive data
   present" (the official meaning of DCD).  If the incoming handshake line
   is disabled, the IIc will stop receiving data (ignore any data on RxD).
   For a hardware handshaking modem, CTS is supposed to mean "You are
   allowed to send me data" (from the modem's point of view).

   If the modem tells the computer to stop transmitting, the computer will
   also be unable to receive, and will discard any data sent by the modem
   while CTS is not active.  This can cause screen corruption and loss of
   data blocks or acknowledgements during a file transfer, which will
   require retransmission.   It is only likely to be a problem while a
   lot of data is being sent, so is more likely to cause problems
   during a file upload than a download.
  
   If the comms software is quick enough, it can drop RTS immediately when
   CTS is lowered, which will prevent the modem from sending any more data.

The original IIc motherboard has another problem: it uses a cheap
method of generating the clock frequency for the serial ports.  Most
implementations based on the 6551 chip use a 1.8432 MHz crystal, which
gives exact baud rates, but the IIc takes the master system clock
(14.31818 MHz in an American IIc) and divides it by eight to produce
1.7898 MHz.  The 3% decrease in clock frequency produces a 3% drop in
the baud rate, which is enough to prevent operation with some serial
devices, particularly intelligent modems running at 1200 bps or faster.

This not always a problem, and I have successfully used one of these
IIc's with a ZyXEL U-1496E modem and a direct connection to a IIgs at
9600 bps.  I have had problems in other cases.

You cannot identify whether you have this motherboard except by
opening up the computer and looking for a tell-tale component.  (I
don't have the details handy.)

You can make a reasonable guess at whether you have the original
motherboard by checking which firmware version is installed in the
IIc.  Get into BASIC, and type PRINT PEEK(64447).

If the value displayed is 255, then you have the original ROM, and
almost certainly have the original motherboard, though it might have
been modified to use a crystal.

If the value displayed is 0, then you might have the original
motherboard or the revised one.  (This ROM version supports the
UniDisk 3.5 drive.)

If the value displayed is 3 or 4, then you have the "memory expansion"
version of the firmware, and almost certainly have the latest
motherboard, which includes a memory expansion slot under the keyboard.

In theory, the IIc's maximum baud rate is 19200.  Whether it can
actually keep up with that rate is another question.  9600 should be fine.
-- 
David Empson
[email-masked]
Snail mail: P.O. Box 27-103, Wellington, New Zealand